#ifndef BASE_H
#define BASE_H
/*
 * file:       Base.h
 * purpose:    basic declarations
 * author:     Santiago
 * copyright:  2008 (c) Creative commons - by-nc-sa - some rights reserved
 *             see http://creativecommons.org/licenses/by-nc-sa/3.0/ for details
 */
#include <inttypes.h>
#include "Config.h"
#ifdef EXTERN
#undef EXTERN
#endif
#ifdef PLACE_GLOBALS_HERE
#define EXTERN 
#else
#define EXTERN extern
#endif
extern void init(void);

struct Work {
   volatile uint32_t time;
   volatile uint32_t otime;
   volatile uint16_t cIPS;
   volatile uint8_t  btPE;
   volatile uint8_t  btT1;
   volatile uint8_t  btT2;
   volatile uint8_t  btT3;
   volatile uint8_t  beep;
};

EXTERN volatile struct Work work
#ifdef PLACE_GLOBALS_HERE
= { .beep = 100 }
#endif
;

/*
 * timer calculations
 */
#ifdef TEST_MODE
#define TIMER_IPS          20
#define IO_CHECK           1                     
#else
#define TIMER_IPS          20000
#define IO_CHECK           1000
#endif
#define TIMER_TOP          999                             // result in 20 kHz PWM

#define BUTTON_SAMPLING    4                               // check button that times
#define USER_TIMEOUT       5                               // timeout in seconds

#endif
