#ifndef STEPPER_H
#define STEPPER_H
/*
 * file:       Stepper.h
 * purpose:    declarations for stepper control
 * author:     Santiago
 * copyright:  2008 (c) Creative commons - by-nc-sa - some rights reserved
 *             see http://creativecommons.org/licenses/by-nc-sa/3.0/ for details
 */
#include <inttypes.h>
#include "Base.h"
#ifdef EXTERN
#undef EXTERN
#endif
#ifdef PLACE_GLOBALS_HERE
#define EXTERN 
#else
#define EXTERN extern
#endif

extern void stepInit(void);
extern void stepSwitchOn(void);
extern void stepSwitchOff(void);
static __inline__ void stepSetSpeed(int8_t delta) { OCR0A += delta; }

#define STEP_CURRENT_MAX   (TIMER_TOP / 3)                 // limit current to 30% of max power

struct StepControl {
   volatile uint32_t steps;
   volatile uint32_t right;
   volatile uint32_t left;
   volatile int16_t  step;
   volatile uint8_t  speed;
   volatile int8_t   direction;
};

EXTERN volatile struct StepControl stepControl
#ifdef PLACE_GLOBALS_HERE
#endif
;

#endif
