/*
 * file:       main.c
 * purpose:    main function, or the second level (low priority) of operations. 
 * author:     Santiago
 * copyright:  2008 (c) Creative commons - by-nc-sa - some rights reserved
 *             see http://creativecommons.org/licenses/by-nc-sa/3.0/ for details
 */
#include <inttypes.h>
#include <stdlib.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#define PLACE_GLOBALS_HERE
#include "Config.h"
#include "Base.h"
#include "LCD.h"
#include "Stepper.h"


PROGMEM  char  line1[] = "Dir: ";
PROGMEM  char  line2[] = "Power: ";


void updateDisplay(void) {
   char  buf[12];

   lcdPrintLine(1, line1);
   itoa(stepControl.direction, buf, 10);
   lcdPrint(buf);

   lcdPrint(" Speed: ");
   itoa(OCR0A, buf, 10);
   lcdPrint(buf);



// 2. line ...
   lcdPrintLine(2, line2);
   itoa(OCR1B, buf, 10);
   lcdPrint(buf);

   lcdPrint(" WF: ");
   itoa(OCR2A, buf, 10);
   lcdPrint(buf);
}


void main(void) {
   init();


   for (;;) {
      if (work.btPE > BUTTON_SAMPLING) {
         work.beep = 10;
         if (stepControl.direction++ > 0)
            stepControl.direction = -1;
      }
      if (work.btT1 > BUTTON_SAMPLING) {
         work.btT1 = 0;
         if (stepControl.direction++ > 0)
            stepControl.direction = -1;
         work.beep = 10;
      }
      if (work.btT2 > BUTTON_SAMPLING) {
         work.btT2 = 0;
         if (OCR1B > 0)
            OCR1B--;
         work.beep = 10;
      }
      if (work.btT3 > BUTTON_SAMPLING) {
         work.btT3 = 0;
         if (++OCR1B > STEP_CURRENT_MAX)
            OCR1B = STEP_CURRENT_MAX;
         work.beep = 10;
      }

      if (work.time != work.otime) {                       // update display once a second
         work.otime = work.time;
         updateDisplay();
      }
   }
}
